package net.za.darkskies.security.sasl;

import java.util.Map;
import javax.security.sasl.*;
import javax.security.auth.callback.CallbackHandler;
import com.sun.security.sasl.util.PolicyUtils;

public final class ExternalFactoryImpl
    implements SaslServerFactory
{

    public ExternalFactoryImpl()
    {
    }

    public SaslServer createSaslServer(
		String mechanism,
		String protocol,
		String serverName,
		Map props,
		CallbackHandler cbh)
        throws SaslException
    {
		if (mechanism.equals(myMechs[EXTERNAL]) && PolicyUtils.checkPolicy(mechPolicies[EXTERNAL], props))
		{
			if (cbh == null)
				throw new SaslException("Callback handler with support for AuthorizeCallback required");
			else
				return new ExternalServer(cbh);
		}
		else
		{
			return null;
		}
    }

    public String[] getMechanismNames(Map map)
    {
		return PolicyUtils.filterMechs(myMechs, mechPolicies, map);
    }

	private static final String myMechs[] =
		{
			"EXTERNAL"
		};
	private static final int EXTERNAL = 0;
	private static final int mechPolicies[] =
		{
			7
		};

}
